# BEGIN COPYRIGHT
# *************************************************************************
# Licensed Materials - Property of IBM 
# 5724-L01, 5655-N53, 5724-I82, 5655-R15
# (C) Copyright IBM Corporation 2008. All rights reserved. 
# US Government Users Restricted Rights - Use, duplication, or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
# *************************************************************************
# END COPYRIGHT

import sys

wasNode = sys.argv[0]
wasCell = sys.argv[1]
wasServer = sys.argv[2]
customCache2002PropsMigrationPath = sys.argv[3]

customCache2002PropertiesScope = '"/Cell:' + wasCell + '/Node:' + wasNode + '/Server:' + wasServer +'/ResourceEnvironmentProvider:Mashups_CacheService"'
#----------------------------------------------------------------
# ID for Mashups Cache Service 2.0.0.2:
#----------------------------------------------------------------

cacheProps2002Id = AdminConfig.getid(customCache2002PropertiesScope)

if cacheProps2002Id != "":
	#----------------------------------------------------------------
	# List Properties for the 2.0.0.2 custom cache properties:
	#----------------------------------------------------------------
	
	cache2002PropsIDsList = AdminConfig.list("J2EEResourceProperty", cacheProps2002Id).splitlines()
	
	#----------------------------------------------------------------
	# Write name = prop to file
	# Cache Service 2.0.0.2
	#----------------------------------------------------------------
	
	f = open(customCache2002PropsMigrationPath, 'w')
	propCount = 0
	for item in cache2002PropsIDsList:
		itemProp = AdminConfig.showall(item).splitlines()
		itemDict = {}
		for item in itemProp:
			item = item[1:len(item) - 1]
			spacePos = item.find(' ')
			itemDict[item[0:spacePos]] = item[spacePos + 1:]
		propCount = propCount + 1
		f.write(itemDict["name"])
		f.write(" = ")
		oldValue = itemDict["value"]
	    
	    # string away the " character
		if oldValue.find('"') != -1:
			newValue = oldValue[1:len(oldValue) - 1]
		elif oldValue.find('[]') != -1:
			newValue = ''
		else:
			newValue = oldValue
		f.write(newValue)
		f.write("\n")
		f.flush()
	f.close()