if(!dojo._hasResource["com.ibm.mm.builder.DeferredUtils"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.DeferredUtils"] = true;
dojo.provide("com.ibm.mm.builder.DeferredUtils");

dojo.require("com.ibm.mm.builder.DeferredImpl");

com.ibm.mm.builder.DeferredUtils = {
	/**
  	 * Loads data from an individual Deferred object, using a cache as a potential data source
  	 * and storing results in the cache on a successful load.
  	 * Returns a new Deferred that can be used by the caller that wraps the original.
  	 * @param {com.ibm.mm.builder.DeferredImpl} dfd	Deferred object to wrap.
	 * @param {Object} cacheContext	object that has a property whose value is the deferred's result. 
	 * @param {String} cacheKey	name of the property on the cacheContext that stores the value of the deferred's result.
	 * @return {com.ibm.mm.builder.DeferredImpl} the new deferred that wraps the original with cache support.
  	 */
	getCacheableDeferred: function(dfd, cacheContext, cacheKey) {
		if(!cacheContext) {
			// if cacheContext is null or undefined, do nothing but return the original since we can't provide
			// any additional semantics over top of the original deferred
			return dfd;
		}
  		return new com.ibm.mm.builder.DeferredImpl(this, function(pseudoDfd, sync, startParams){
  			var cbk = pseudoDfd.getFinishedCallback(),
				parms = pseudoDfd.getFinishedCallbackParameters();
  			if(cacheContext[cacheKey]) {
  				if(cbk) {
  					cbk(cacheContext[cacheKey], 200, parms); // call callback immediately
  				}
  				return cacheContext[cacheKey];	// return in sync mode
  			}
  			else {
  				dfd.setFinishedCallback(function(res, status, cbkParms){
  					if(status === 200) {
  						cacheContext[cacheKey] = res;	// store in cache if successful
  					}
  					if(cbk) {
	  					cbk(res, status, cbkParms); // call callback
	  				}
  				}, parms);
  				return dfd.start(sync);
  			}
  		}, {});
  	}
};

}
