dojo.provide("com.ibm.pb.extension.Operations");

dojo.declare("com.ibm.pb.extension.SimpleOperation", [com.ibm.mashups.enabler.ac.operation.Operation], {
	allowed: false,
	constructor: function(allowed, finished) {
		this.allowed = allowed;
		if(finished) {
			finished(this);
		}
	},
	isAllowed: function(context){
		return this.allowed;
	}
});

(function(){
	var ops = com.ibm.pb.extension.Operations = {
		PAGE_ACTIONS: "com.ibm.pb.extension.Operations.pageActions",
		CREATE_PAGE: "com.ibm.pb.extension.Operations.createPage"
	}, 	simpleOp = com.ibm.pb.extension.SimpleOperation,
		enabler = com.ibm.mashups.enabler,
		allowedOpsModel = enabler.ac.operation.AllowedOperationsModelFactory.getAllowedOperationsModel(),
		navModel = enabler.navigation.Factory.getNavigationModel(),
		navConstants = enabler.navigation.Constants;
	
	/**
	 * PAGE_ACTIONS operation by default is allowed if the user is logged in.
	 */
	allowedOpsModel.setOperation(ops.PAGE_ACTIONS, function(opName, jsonContext, sync, finished){
		new simpleOp(enabler.user.Factory.getUserModel().getAnonymousMode() != enabler.user.AnonymousMode.ANONYMOUS, finished);
	});
	
	/**
	 * CREATE_PAGE operation by default is allowed if the user can insert a private node
	 * under the jsonContext.navNode|contentNode of if the user can insert a public node under
	 * the jsonContext.navNode|contentNode .
	 */
	allowedOpsModel.setOperation(ops.CREATE_PAGE, function(opName, jsonContext, sync, finished){
		var currentNavNode = jsonContext.navNode || jsonContext.contentNode,
			canCreatePage = dojo.some([true, false], function(isPrivate){
				var res = false, args = {type: navConstants.NAVIGATION_PAGE};
				if(isPrivate) {
					args["private"] = true;
				}
				if(navModel.confirmCreate(args)){
					var dummyPage = navModel.create(args);
					res = navModel.confirmInsert(dummyPage,currentNavNode);
				}
				return res;
			});
		new simpleOp(canCreatePage, finished);
	});
		
})();