dojo.provide("com.ibm.pb.layout.LayoutParser");

(function(){
	var lp = com.ibm.pb.layout.LayoutParser = {
		CONTAINER_QUERY: ".component-container",
		CONTROL_QUERY: ".component-control",
		ROOT_NODE_ID: "layoutContainers",
		ID_MATCHER: /id-([\S]+)/,
		_rootNode: null,
		_containersCache:null,
		
		extractID: function(layoutDOMNode) {
			var m = (dojo.attr(layoutDOMNode, "class") || "").match(lp.ID_MATCHER);
			return m && m[1];
		},
		findById: function(id) {
			//In IE 7, The query with detailed path -E.g.> .component-container > .id- costs less than 10% of whole page -e.g .id-
			if(!id) return null;
			var ele= dojo.query("> .component-container > .id-"+ id,this.getRootNode());//check from visible layout container
			if (!!ele && ele.length>0) {
				return ele[0];
			}
			ele = dojo.query("> .hiddenWidgetsDiv > .component-container > .id-" +id,this.getRootNode());//check from hidden container
			if (!!ele && ele.length>0) {
				return ele[0];
			}
			return dojo.query(".id-" + id, this.getRootNode())[0];
		},
		findContainers: function(root) {
			if(root == this.getRootNode()){//most request for containers are from root
				if(!this._containersCache){
					this._containersCache = dojo.query(lp.CONTAINER_QUERY, root); 
				}
				return this._containersCache;
			}else {
				return dojo.query(lp.CONTAINER_QUERY, root); 
			}
		},
		findControls: function(root) {
			return dojo.query(lp.CONTROL_QUERY, root);
		},
		getRootNode: function(){
			if(!lp._rootNode) {
				lp._rootNode = dojo.byId(lp.ROOT_NODE_ID);
			}
			return lp._rootNode;
		},
		clearCachedContainers:function(){
			this._containersCache=null;
		}
	};
})();