/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.runtime.skin.DynamicContentFilterChain");

//<INTERFACE>
dojo.require("com.ibm.mashups.enabler.runtime.skin.FilterControl");

/**
 * Filters use the FilterChain to invoke the next filter in the chain
 *
 * @private
 * @ibm-module CoreModel
 * @since 2.4
 */
dojo.declare( "com.ibm.mashups.enabler.runtime.skin.DynamicContentFilterChain", null, {
	/**
	 * Calls the next filter in the chain's onChangingDynamicContent or onChangeDynamicContent methods
	 * @param {com.ibm.mashups.enabler.layout.LayoutNode} layoutNode LayoutNode which contains this skin. Will not be <code>null</code>.
     * @param {String} name name of the client side dynamic content spot to return. May not be <code>null</code>
     * @param {String} oldValue old value of the client side dynamic content spot, <code>null</code> if it does not exist
     * @param {String} newValue new value of the client side dynamic content spot. If <code>null</code>, then the value for this dynamic content spot will be cleared
     * @param {FilterControl} control object used for a filter to disagree.  This is only applicable
     *                                on a filter's <code>onChangingDynamicContent()</code> method.
     * @type void
	 */
	doFilter: function(layoutNode, name, oldValue, newValue, control) {
	}
});
//</INTERFACE>

dojo.require("com.ibm.mm.enabler.runtime.skin.DynamicContentFilterChainImpl");
